﻿namespace HealthMonitor.Core.Pipeline.Aop
{
    public abstract class AopValueBase : IValue<CacheInterceptorContext>
    {
        public IValue<CacheInterceptorContext> Next { get; set; } = default!;

        public abstract Task Invoke(CacheInterceptorContext context);

        /// <summary>
        /// 执行下一个管道阀门
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        protected async Task InvokeNextAsync(CacheInterceptorContext context)
        {
            if (Next != null) await Next.Invoke(context);
        }
    }
}
